module dataread
use globvar
implicit none

contains

subroutine datareadroutine
use globvar
implicit none

! This subroutine reads the data and random shock files.

integer :: i,j

! (1) outcome variables: pol_passage in_col in_oil in_nuc in_bio in_ren 

	open(10, file="data_outcome.txt")
    do i=1,np
		read (10,"(5(i1,1x))"), rst_psg(i), rst_ptn(i,1), rst_ptn(i,2), rst_ptn(i,3), rst_ptn(i,4)		
	end do
	close(10)

    ! total lobbying spending (unitm: million dollars)

	rst_spd(1) = 77.85388281250d0*unitm
	rst_spd(2) = 73.21569531250d0*unitm
	rst_spd(3) = 33.91512890625d0*unitm
	rst_spd(4) = 22.11119335938d0*unitm

	
! (2) regressors: 

	do i = 1,np
		Z(i,1) = 1.0d0
	end do

	open(20, file="data_explanatory.txt")
        do i=1,np
		read (20,"(4(f1.0,1x))"), Z(i,2),Z(i,3),Z(i,4),Z(i,5) 
	end do
	close(20)

	open(22, file="data_explanatory2.txt")
        do i=1,np
                read (22,"(4(i1,1x),4(f1.0,1x))"), W(i,1),W(i,2),W(i,3),W(i,4),X(i,1),X(i,2),X(i,3),X(i,4)
        end do
	close(22)

	open(21, file="data_polling.txt")
	do i = 1,np
	    read(21,*), Z(i,6)
	end do
	close(21)	
	
	do i=1,np
	    do j = 1,nr
	        if (W(i,j)==0) then
	            W(i,j) = -1
	        end if
	    end do
	end do
	

    open(30, file="data_conditional.txt")
    do i = 1,np
        read(30,"(i1,1x,i1,1x,i3,1x,i3,1x)"), Ct(i,1),Ct(i,2),Cn(i,1),Cn(i,2)
    end do
    close(30)
    
    do i = 1,np
        Cn(i,1) = Cn(i,1)-100
        Cn(i,2) = Cn(i,2)-100
    end do


    open(31, file="data_billid.txt")
    do i = 1,nb
        read(31,"(i4,1x,i4,1x,i4,1x)"), bp(i,1),bp(i,2),bp(i,3)
        bp(i,1) = bp(i,1)- 1000
        bp(i,2) = bp(i,2)- 1000
        bp(i,3) = bp(i,3)- 1000
    end do
    close(31)

! (3) shocks

	open(40, file="simshock1.txt")      	
	do i=1,nn
		read (40,"(f15.8)"), simshock(i,1)
	end do
	close(40)
	open(41, file="simshock2.txt")
	do i=1,nn
		read (41,"(f15.8)"), simshock(i,2)
	end do
	close(41)
	open(42, file="simshock3.txt") 
	do i=1,nn
		read (42,"(f15.8)"), simshock(i,3)
	end do
	close(42)
	open(43, file="simshock4.txt") 
	do i=1,nn
		read (43,"(f15.8)"), simshock(i,4)
	end do
	close(43)
	open(44, file="simshock5.txt") 
	do i=1,nn
		read (44,"(f15.8)"), simshock(i,5)
	end do
	close(44)
	open(46, file="parshock.txt")
	do i = 1,nci
	    do j = 1,npar
	        read (46, *) parshock(i,j)    
	    end do
	end do    
	close(46)

	do i = 1,nr
		ptn(1,i) = 0
	end do
	do i = 1,(num-1)
		call dec2bin(i,nr,ptn((i+1),:))
	end do	

contains

subroutine dec2bin(dec,len,bin)

integer, intent(in) :: dec
integer, intent(in) :: len
integer, intent(out) :: bin(len)

integer :: bindec, decc, i

i = len
decc = dec

do while (i.ge.1) 
	bindec = 2**(i-1)
	if ((decc - bindec) .ge. 0) then
		bin(len-i+1) = 1
		decc = decc -bindec
	else
		bin(len-i+1) = 0
	end if
	i = i - 1
end do

end subroutine dec2bin

end subroutine datareadroutine

end module dataread