module globvar
implicit none

character(50) :: inputfilename
character(50) :: outputfilename

integer, parameter :: npar = 23             ! Number of parameters
integer, parameter :: np = 445				! Number of policies
integer, parameter :: nr =  4				! Number of players
integer, parameter :: num = 16              ! Number of entry profile
integer, parameter :: ns = 5000    			! Number of simulations (default: 5,000)
integer, parameter :: nn = (ns+4)*np		! ns*np for likelihood/simulation, np*2 for montecarlo.
integer, parameter :: nd = nr+1				! Dimemsion of shocks2
integer, parameter :: nci = 5000            ! Number of simulations for confidence interval
real, parameter :: unitm = 1000000.0d0      ! unit of money: miliion dollars
integer, parameter :: main_node = 0

!Data
real(8), dimension(np,7) :: Z				! Policy characteristics1 (initial)
real(8), dimension(np,nr) :: X  			! Policy characteristics2 (value)
integer, dimension(np,nr) :: W				! Position of players  

integer, dimension(np) :: rst_psg			! Passage
integer, dimension(np,nr) :: rst_ptn		! Participation 
real(8), dimension(nr) :: rst_spd			! Spending

!Shocks for simulation
real(8), dimension(nn,nd) :: simshock
real(8), dimension(nci,npar) :: parshock

!Parameter
!Fixed parameters
real(8), parameter :: ect = 5000.0d0        ! maximum entry cost
real(8), dimension(np) :: ecost

!Not normalized parameters
real(8) :: bf, ba, gam                    	! lobbying production function
real(8) :: del(7), varin   					! initial prob			
real(8) :: alp(nr*2), varvu(nr)				! value distribution

!Equilibrium calculation
integer :: ptn(num,nr)                      ! entry profiles
integer :: seed
integer:: nproc

!Parameters in estimation
real(8) :: weight, lambda
real(8), dimension(npar) :: scale_par
real(8), dimension(nr)   :: lagr                        ! lagr is for calculating asymptotic variance

!Categories for conditional moment calculation
integer, dimension(np,2) :: Ct,Cn                       ! categories
integer, parameter :: ncat1 = 3                         ! num of categories for (final status)
integer, parameter :: ncat2 = 4                         ! num of categories for (dispute)

end module globvar
